from rede.model import TransactionStatus


class FindResponse(object):
    def __init__(self):
        self.return_code = 0
        self.messages = []
        self.tid = ""
        self.status = ""
        self.distributor_affiliation = ""
        self.capture = ""
        self.installments = ""
        self.date = ""
        self.time = ""
        self.amount = ""
        self.currency = ""
        self.order_id = ""
        self.authorization_number = ""
        self.nsu = ""
        self.soft_descriptor = ""
        self.card_number = ""
        self.card_holder_name = ""
        self.exp_date_authorization = ""
        self.confirm_date_authorization = ""
        self.refund_date = ""
        self.departure_tax = ""
        self.avs_response = ""
        self.avs_message = ""
        self.postal_code = ""
        self.address_street = ""
        self.address_number = ""
        self.address_complement = ""
        self.document = ""
        self.cavv = ""
        self.eci = ""
        self.xid = ""
        self.origin = ""

    @staticmethod
    def map(obj_wcf):
        find_response = FindResponse()

        if obj_wcf.REGISTRO is not None:

            if obj_wcf.REGISTRO.COD_RET != "":
                find_response.return_code = obj_wcf.REGISTRO.COD_RET
            else:
                find_response.return_code = TransactionStatus.transaction_not_processed

            find_response.messages.append(obj_wcf.REGISTRO.MSG_RET)
            find_response.tid = obj_wcf.REGISTRO.TID
            find_response.status = obj_wcf.REGISTRO.STATUS
            find_response.distributor_affiliation = obj_wcf.REGISTRO.FILIACAO_DSTR
            find_response.capture = obj_wcf.REGISTRO.TRANSACAO
            find_response.installments = obj_wcf.REGISTRO.PARCELAS
            find_response.date = obj_wcf.REGISTRO.DATA
            find_response.time = obj_wcf.REGISTRO.HORA
            find_response.amount = obj_wcf.REGISTRO.TOTAL
            find_response.currency = obj_wcf.REGISTRO.MOEDA
            find_response.order_id = obj_wcf.REGISTRO.NUMPEDIDO
            find_response.authorization_number = obj_wcf.REGISTRO.NUMAUTOR
            find_response.nsu = obj_wcf.REGISTRO.NUMSQN
            find_response.soft_descriptor = obj_wcf.REGISTRO.IDENTIFICACAOFATURA
            find_response.card_number = obj_wcf.REGISTRO.NR_CARTAO
            find_response.card_holder_name = obj_wcf.REGISTRO.NOM_PORTADOR
            find_response.exp_date_authorization = obj_wcf.REGISTRO.DATA_EXP_PRE_AUT
            find_response.confirm_date_authorization = obj_wcf.REGISTRO.DATA_CON_PRE_AUT
            find_response.refund_date = obj_wcf.REGISTRO.DATA_CANC
            find_response.departure_tax = obj_wcf.REGISTRO.TAXA_EMBARQUE
            find_response.origin = obj_wcf.REGISTRO.ORIGEM

            if obj_wcf.REGISTRO.AVS is not None:
                find_response.avs_response = obj_wcf.REGISTRO.AVS.RESP_AVS
                find_response.avs_message = obj_wcf.REGISTRO.AVS.MSG_AVS
                find_response.postal_code = obj_wcf.REGISTRO.AVS.CEP
                find_response.address_street = obj_wcf.REGISTRO.AVS.ENDERECO
                find_response.address_number = obj_wcf.REGISTRO.AVS.NU_ENDERECO
                find_response.address_complement = obj_wcf.REGISTRO.AVS.COMPLEMENTO
                find_response.document = obj_wcf.REGISTRO.AVS.CPF

            if obj_wcf.REGISTRO._x0033_DS is not None:
                find_response.cavv = obj_wcf.REGISTRO._x0033_DS.CAVV
                find_response.eci = obj_wcf.REGISTRO._x0033_DS.ECI
                find_response.xid = obj_wcf.REGISTRO._x0033_DS.XID

        return find_response
