from rede.model.TransactionType import TransactionType


class GetAuthorizedCreditRequest(object):
    def __init__(self):
        self.amount = 0.0
        self.transaction = 0
        self.order_id = ""
        self.card_number = ""
        self.security_code = ""
        self.expiration_month = 0
        self.expiration_year = 0
        self.card_holder_name = ""
        self.soft_descriptor = ""
        self.subscription = ""
        self.origin = ""
        self.postal_code = ""
        self.address_complement = ""
        self.document = ""
        self.address_street = ""
        self.address_number = ""
        self.installments = ""
        self.capture = True

    @staticmethod
    def map(obj_wcf, credit_request, security):

        obj_wcf.Filiacao = security.affiliation
        obj_wcf.Senha = security.password

        obj_wcf.Total = u"{0:.2f}".format(credit_request.amount)
        obj_wcf.Parcelas = credit_request.installments
        obj_wcf.NumPedido = credit_request.order_id
        obj_wcf.Nrcartao = credit_request.card_number
        obj_wcf.Cvc2 = credit_request.security_code
        obj_wcf.Mes = u"{0:02d}".format(credit_request.expiration_month)
        obj_wcf.Ano = credit_request.expiration_year
        obj_wcf.Portador = credit_request.card_holder_name
        obj_wcf.IdentificacaoFatura = credit_request.soft_descriptor
        obj_wcf.Recorrente = credit_request.subscription
        obj_wcf.Origem = credit_request.origin
        obj_wcf.Cep = credit_request.postal_code
        obj_wcf.Complemento = credit_request.address_complement
        obj_wcf.Cpf = credit_request.document
        obj_wcf.Endereco = credit_request.address_street

        if credit_request.capture:
            obj_wcf.Transacao = TransactionType.installment_credit_issuer > 1 if credit_request.installments else TransactionType.credit
        else:
            obj_wcf.Transacao = TransactionType.pre_authorization

        return obj_wcf
