from rede.model import TransactionStatus


class GetAuthorizedCreditResponse(object):
    def __init__(self):
        self.cet = ""
        self.return_code = 0
        self.interest_rate = ""
        self.avs_message = ""
        self.avs_response = ""
        self.messages = []
        self.authorization_number = ""
        self.order_id = ""
        self.nsu = ""
        self.tid = ""
        self.installments_amount = ""
        self.totalInterest_rate = ""
        self.date = ""
        self.time = ""

    @staticmethod
    def map(obj_wcf):
        credit_response = GetAuthorizedCreditResponse()

        if obj_wcf.CodRet != "":
            credit_response.return_code = obj_wcf.CodRet
        else:
            credit_response.return_code = TransactionStatus.transaction_not_processed

        credit_response.messages.append(obj_wcf.Msgret)

        credit_response.cet = obj_wcf.Cet
        credit_response.interest_rate = obj_wcf.Juros
        credit_response.avs_message = obj_wcf.MsgAvs
        credit_response.avs_response = obj_wcf.RespAvs
        credit_response.authorization_number = obj_wcf.NumAutor
        credit_response.order_id = obj_wcf.NumPedido
        credit_response.nsu = obj_wcf.NumSqn
        credit_response.tid = obj_wcf.Tid
        credit_response.installments_amount = obj_wcf.ValParcelas
        credit_response.total_interest_rate = obj_wcf.ValTotalJuros
        credit_response.date = obj_wcf.Data
        credit_response.time = obj_wcf.Hora

        return credit_response

